/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: exception.h,v 1.2 2008/05/26 09:06:08 myasuma Exp $
 */

/*
 *		CPU㳰ǽ
 */

#ifndef TOPPERS_EXCEPTION_H
#define TOPPERS_EXCEPTION_H

#ifndef OMIT_INITIALIZE_EXCEPTION

/*
 *  CPU㳰ϥɥ֥å
 */
typedef struct cpu_exception_handler_initialization_block {
	EXCNO		excno;			/* CPU㳰ϥɥֹ */
	ATR			excatr;			/* CPU㳰ϥɥ° */
	FP			exc_entry;		/* CPU㳰ϥɥν */
} EXCINIB;

/*
 *  CPU㳰ϥɥֹοkernel_cfg.c
 */
extern const uint_t	tnum_excno;

/*
 *  CPU㳰ϥɥ֥åΥꥢkernel_cfg.c
 */
extern const EXCINIB	excinib_table[];

#endif /* OMIT_INITIALIZE_EXCEPTION */

/*
 *  CPU㳰ϥɥǽν
 */
extern void	initialize_exception(void);

#endif /* TOPPERS_EXCEPTION_H */
