/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007,2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_mutex5.c,v 1.2 2008/05/26 09:05:23 myasuma Exp $
 */

/* 
 *		ߥ塼ƥåΥƥ(5)
 *
 * ڥƥȤŪ
 *
 *  TA_CEILING°Υߥ塼ƥåФơߥ塼ƥåκƽ
 *  Ū˥ƥȤ롥
 *
 * ڥƥȹܡ
 *
 *	(A) ߥ塼ƥåνini_mtx
 *		(A-1) ߥ塼ƥååƤͥ٤뤳
 *		ȡ
 *		(A-2) (A-1)η̡ǥѥå뤳ȡ
 *		(A-3) ߥ塼ƥåԤäƤԤ뤳ȡ
 *		(A-4) (A-3)η̡ǥѥå뤳ȡ
 *
 * ڥƥȹܤμ¸ˡ
 *
 *	(A-1)
 *		ͥ٥ˡͥ٥ߥ塼ƥååͥ
 *		顤Υߥ塼ƥåƽ롥
 *	(A-2)
 *		ͥ٥ˡͥ٥ߥ塼ƥååΥ
 *		顤Υߥ塼ƥåƽȡͥ٥
 *		괹뤳Ȥǧ롥
 *	(A-3)
 *		(A-1)ΥƥȻˡͥ٥˥åԤƤΥ
 *		Ԥ뤳Ȥǧ롥
 *	(A-4)
 *		ͥ٥ˡͥ٥ߥ塼ƥåå˹
 *		ͥ٥˥åԤƤͥ٥顤
 *		ߥ塼ƥåƽȡͥ٥Ԥ졤
 *		Υڤ괹뤳Ȥǧ롥
 *
 * ڻѥ꥽
 *
 *	TASK1: ͥ٥ᥤ󥿥ǽ餫鵯ư
 *	TASK2: ͥ٥
 *	TASK3: ͥ٥
 *	MTX1: ߥ塼ƥåTA_CEILING°¤Ϲͥ١
 *	MTX2: ߥ塼ƥåTA_CEILING°¤ͥ١
 *
 * ڥƥȥ󥹡
 *
 *	== TASK1ͥ١==
 *		call(set_bit_func(bit_mutex))
 *	1:	loc_mtx(MTX2)
 *	2:	act_tsk(TASK2)
 *	3:	rot_rdq(MID_PRIORITY)
 *	== TASK2ͥ١==
 *	4:	loc_mtx(MTX2) -> E_DLT
 *	== TASK1³==
 *	5:	act_tsk(TASK3)
 *	== TASK3ͥ١==
 *	6:	ini_mtx(MTX2)			... (A-1)(A-3)
 *	7:	ref_mtx(MTX2, &rmtx)
 *		assert(rmtx.htskid == TSK_NONE)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		slp_tsk()
 *	== TASK2³==
 *	8:	slp_tsk()
 *	== TASK1³==
 *	9:	loc_mtx(MTX1)
 *	10:	wup_tsk(TASK2)
 *	11:	ini_mtx(MTX1)			... (A-2)
 *	== TASK2³==
 *	12:	slp_tsk()
 *	== TASK1³==
 *	13:	loc_mtx(MTX1)
 *	14:	wup_tsk(TASK3)
 *	15:	rot_rdq(HIGH_PRIORITY)
 *	== TASK3³==
 *	16:	loc_mtx(MTX1) -> E_DLT
 *	== TASK1³==
 *	17:	wup_tsk(TASK2)
 *	18:	tslp_tsk(10) -> E_TMOUT
 *	== TASK2³==
 *	19:	ini_mtx(MTX1)			... (A-4)
 *	== TASK3³==
 *	20:	ext_tsk() -> noreturn
 *	== TASK2³==
 *	21:	ext_tsk() -> noreturn
 *	== TASK1³==
 *	22: END
 */

#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/logtask.h"
#include "kernel_cfg.h"
#include "test_lib.h"
#include "test_mutex5.h"

extern ER	bit_mutex(void);

void
task1(intptr_t exinf)
{
	ER		ercd;

	set_bit_func(bit_mutex);

	check_point(1);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(2);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(3);
	ercd = rot_rdq(MID_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(5);
	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(9);
	ercd = loc_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(10);
	ercd = wup_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(11);
	ercd = ini_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(13);
	ercd = loc_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(14);
	ercd = wup_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(15);
	ercd = rot_rdq(HIGH_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(17);
	ercd = wup_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(18);
	ercd = tslp_tsk(10);
	check_ercd(ercd, E_TMOUT);

	check_finish(22);

	check_point(0);
}

void
task2(intptr_t exinf)
{
	ER		ercd;

	check_point(4);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_DLT);

	check_point(8);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(12);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(19);
	ercd = ini_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(21);
	ercd = ext_tsk();

	check_point(0);
}

void
task3(intptr_t exinf)
{
	ER		ercd;
	T_RMTX	rmtx;

	check_point(6);
	ercd = ini_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(7);
	ercd = ref_mtx(MTX2, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TSK_NONE);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(16);
	ercd = loc_mtx(MTX1);
	check_ercd(ercd, E_DLT);

	check_point(20);
	ercd = ext_tsk();

	check_point(0);
}
