/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_mutex7.c,v 1.2 2008/05/26 09:05:24 myasuma Exp $
 */

/* 
 *		ߥ塼ƥåΥƥ(7)
 *
 * ڥƥȤŪ
 *
 *  TA_CEILING°Υߥ塼ƥåФơζλΥߥ塼
 *  ƥåϢνŪ˥ƥȤ롥
 *
 * ڥƥȹܡ
 *
 *	(A) ζλter_tsk
 *		(A-1) åƤߥ塼ƥå1ġˤå뤳ȡ
 *		(A-2) åƤߥ塼ƥå1ġˤå졤
 *		ԤäƤåͥ٤Ѳ
 *		뤳ȡ
 *		(A-3) (A-2)η̡ǥѥå뤳ȡ
 *		(A-4) åƤߥ塼ƥåʣˤ٤ƥå
 *		뤳ȡ
 *		(A-5) åƤߥ塼ƥåʣˤå졤
 *		ԤäƤʣˤåͥ٤
 *		Ԥ뤳ȡ
 *		(A-6) (A-5)η̡ǥѥå뤳ȡ
 *
 * ڥƥȹܤμ¸ˡ
 *
 *	(A-1)
 *		2ͥ١ˤ˥ߥ塼ƥåå1饿
 *		2ter_tskȡå뤳Ȥǧ롥
 *	(A-2)
 *		2ͥ١ˤͥ٥ߥ塼ƥåå
 *		3ͥ١ˤ˥åԤ֤ǡ1ʹͥ١ˤ
 *		2ter_tskȡ3ͥ٤ˤʤäԤ
 *		Ȥǧ롥
 *	(A-3)
 *		2ͥ١ˤͥ٥ߥ塼ƥåå
 *		3ͥ١ˤ˥åԤ֤ǡ1ͥ١ˤ
 *		2ter_tskȡ3ͥ٤ˤʤäԤ졤
 *		3ڤ괹뤳Ȥǧ롥
 *	(A-4)
 *		2ͥ١ˤ˥ߥ塼ƥå2ĥå1
 *		2ter_tskȡξΥå뤳Ȥǧ롥
 *	(A-5)
 *		2ͥ١ˤ˹ͥ٥ߥ塼ƥå2ĥå
 *		3ͥ١ˤȥ4ͥ١ˤˤ줾ΥåԤ
 *		֤ǡ1ʹͥ١ˤ饿2ter_tskȡ
 *		3ȥ4ͥ٤ˤʤäԤ뤳Ȥǧ롥
 *	(A-6)
 *		2ͥ١ˤ˹ͥ٥ߥ塼ƥå2ĥå
 *		3ͥ١ˤȥ4ͥ١ˤˤ줾ΥåԤ
 *		֤ǡ1ͥ١ˤ饿2ter_tskȡ
 *		3ȥ4ͥ٤ˤʤäԤ졤3ڤ괹
 *		Ȥǧ롥
 *
 * ڻѥ꥽
 *
 *	TASK1: ͥ٥ᥤ󥿥ǽ餫鵯ư
 *	TASK2: ͥ٥
 *	TASK3: ͥ٥
 *	TASK4: ͥ٥
 *	MTX1: ߥ塼ƥåTA_CEILING°¤ͥ١
 *	MTX2: ߥ塼ƥåTA_CEILING°¤ͥ١
 *
 * ڥƥȥ󥹡
 *
 *	== TASK1ͥ١==
 *		call(set_bit_func(bit_mutex))
 *	1:	act_tsk(TASK2)
 *	2:	slp_tsk()
 *	== TASK2-1ͥ١==
 *	3:	loc_mtx(MTX1)
 *	4:	wup_tsk(TASK1)
 *	== TASK1³==
 *	5:	ter_tsk(TASK2)			... (A-1)
 *	6:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TSK_NONE)
 *		assert(rmtx.wtskid == TSK_NONE)
 *
 *	7:	act_tsk(TASK2)
 *		act_tsk(TASK3)
 *	8:	slp_tsk()
 *	== TASK2-2ͥ١==
 *	9:	loc_mtx(MTX1)
 *	10:	tslp_tsk(10) -> E_TMOUT
 *	== TASK3-1ͥ١==
 *	11:	loc_mtx(MTX1)
 *	== TASK2-2³==
 *	12:	wup_tsk(TASK1)
 *	== TASK1³==
 *	13:	ter_tsk(TASK2)			... (A-2)
 *	14:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TASK3)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_tsk(TASK3, &rtsk)
 *		assert(rtsk.tskpri == MID_PRIORITY)
 *	15:	ter_tsk(TASK3)
 *
 *	16:	act_tsk(TASK2)
 *		act_tsk(TASK3)
 *	17:	chg_pri(TSK_SELF, LOW_PRIORITY)
 *	== TASK2-3ͥ١==
 *	18:	loc_mtx(MTX1)
 *	19:	slp_tsk()
 *	== TASK3-2ͥ١==
 *	20:	loc_mtx(MTX1)
 *	== TASK1³==
 *	21:	ter_tsk(TASK2)			... (A-3)
 *	== TASK3-2³==
 *	22:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TASK3)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_tsk(TASK3, &rtsk)
 *		assert(rtsk.tskpri == MID_PRIORITY)
 *	23:	ext_tsk() -> noreturn
 *	== TASK1³==
 *	24:	chg_pri(TSK_SELF, HIGH_PRIORITY)
 *
 *	25:	act_tsk(TASK2)
 *	26:	slp_tsk()
 *	== TASK2-4ͥ١==
 *	27:	loc_mtx(MTX1)
 *		loc_mtx(MTX2)
 *	28:	wup_tsk(TASK1)
 *	== TASK1³==
 *	29:	ter_tsk(TASK2)			... (A-4)
 *	30:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TSK_NONE)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_mtx(MTX2, &rmtx)
 *		assert(rmtx.htskid == TSK_NONE)
 *		assert(rmtx.wtskid == TSK_NONE)
 *	31:	MISSING
 *
 *	32:	act_tsk(TASK2)
 *		act_tsk(TASK3)
 *		act_tsk(TASK4)
 *	33:	slp_tsk()
 *	== TASK2-5ͥ١==
 *	34:	loc_mtx(MTX1)
 *		loc_mtx(MTX2)
 *	35:	tslp_tsk(10) -> E_TMOUT
 *	== TASK3-3ͥ١==
 *	36:	loc_mtx(MTX1)
 *	== TASK4-1ͥ١==
 *	37:	loc_mtx(MTX2)
 *	== TASK2-5³==
 *	38:	wup_tsk(TASK1)
 *	== TASK1³==
 *	39:	ter_tsk(TASK2)			... (A-5)
 *	40:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TASK3)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_mtx(MTX2, &rmtx)
 *		assert(rmtx.htskid == TASK4)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_tsk(TASK3, &rtsk)
 *		assert(rtsk.tskpri == MID_PRIORITY)
 *		ref_tsk(TASK4, &rtsk)
 *		assert(rtsk.tskpri == MID_PRIORITY)
 *	41:	ter_tsk(TASK3)
 *		ter_tsk(TASK4)
 *
 *	42:	act_tsk(TASK2)
 *		act_tsk(TASK3)
 *		act_tsk(TASK4)
 *	43:	chg_pri(TSK_SELF, LOW_PRIORITY)
 *	== TASK2-6ͥ١==
 *	44:	loc_mtx(MTX1)
 *		loc_mtx(MTX2)
 *	45:	slp_tsk()
 *	== TASK3-4ͥ١==
 *	46:	loc_mtx(MTX1)
 *	== TASK4-2ͥ١==
 *	47:	loc_mtx(MTX2)
 *	== TASK1³==
 *	48:	ter_tsk(TASK2)			... (A-6)
 *	== TASK3-4³==
 *	49:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TASK3)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_mtx(MTX2, &rmtx)
 *		assert(rmtx.htskid == TASK4)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_tsk(TASK3, &rtsk)
 *		assert(rtsk.tskpri == MID_PRIORITY)
 *		ref_tsk(TASK4, &rtsk)
 *		assert(rtsk.tskpri == MID_PRIORITY)
 *	50:	ext_tsk() -> noreturn
 *	== TASK4-2³==
 *	51:	ext_tsk() -> noreturn
 *	== TASK1³==
 *	52: END
 */

#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/logtask.h"
#include "kernel_cfg.h"
#include "test_lib.h"
#include "test_mutex7.h"

extern ER	bit_mutex(void);

void
task1(intptr_t exinf)
{
	ER		ercd;
	T_RTSK	rtsk;
	T_RMTX	rmtx;

	set_bit_func(bit_mutex);

	check_point(1);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(2);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(5);
	ercd = ter_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(6);
	ercd = ref_mtx(MTX1, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TSK_NONE);
	check_assert(rmtx.wtskid == TSK_NONE);

	check_point(7);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(8);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(13);
	ercd = ter_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(14);
	ercd = ref_mtx(MTX1, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TASK3);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = ref_tsk(TASK3, &rtsk);
	check_ercd(ercd, E_OK);
	check_assert(rtsk.tskpri == MID_PRIORITY);

	check_point(15);
	ercd = ter_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(16);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(17);
	ercd = chg_pri(TSK_SELF, LOW_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(21);
	ercd = ter_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(24);
	ercd = chg_pri(TSK_SELF, HIGH_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(25);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(26);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(29);
	ercd = ter_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(30);
	ercd = ref_mtx(MTX1, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TSK_NONE);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = ref_mtx(MTX2, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TSK_NONE);
	check_assert(rmtx.wtskid == TSK_NONE);

	check_point(31);

	check_point(32);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	ercd = act_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(33);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(39);
	ercd = ter_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(40);
	ercd = ref_mtx(MTX1, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TASK3);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = ref_mtx(MTX2, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TASK4);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = ref_tsk(TASK3, &rtsk);
	check_ercd(ercd, E_OK);
	check_assert(rtsk.tskpri == MID_PRIORITY);

	ercd = ref_tsk(TASK4, &rtsk);
	check_ercd(ercd, E_OK);
	check_assert(rtsk.tskpri == MID_PRIORITY);

	check_point(41);
	ercd = ter_tsk(TASK3);
	check_ercd(ercd, E_OK);

	ercd = ter_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(42);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	ercd = act_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(43);
	ercd = chg_pri(TSK_SELF, LOW_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(48);
	ercd = ter_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_finish(52);

	check_point(0);
}

static uint_t	task2_count = 0;

void
task2(intptr_t exinf)
{
	ER		ercd;

	switch (++task2_count) {
	case 1:
		check_point(3);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(4);
		ercd = wup_tsk(TASK1);
		check_ercd(ercd, E_OK);

		check_point(0);

	case 2:
		check_point(9);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(10);
		ercd = tslp_tsk(10);
		check_ercd(ercd, E_TMOUT);

		check_point(12);
		ercd = wup_tsk(TASK1);
		check_ercd(ercd, E_OK);

		check_point(0);

	case 3:
		check_point(18);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(19);
		ercd = slp_tsk();
		check_ercd(ercd, E_OK);

		check_point(0);

	case 4:
		check_point(27);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		ercd = loc_mtx(MTX2);
		check_ercd(ercd, E_OK);

		check_point(28);
		ercd = wup_tsk(TASK1);
		check_ercd(ercd, E_OK);

		check_point(0);

	case 5:
		check_point(34);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		ercd = loc_mtx(MTX2);
		check_ercd(ercd, E_OK);

		check_point(35);
		ercd = tslp_tsk(10);
		check_ercd(ercd, E_TMOUT);

		check_point(38);
		ercd = wup_tsk(TASK1);
		check_ercd(ercd, E_OK);

		check_point(0);

	case 6:
		check_point(44);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		ercd = loc_mtx(MTX2);
		check_ercd(ercd, E_OK);

		check_point(45);
		ercd = slp_tsk();
		check_ercd(ercd, E_OK);

		check_point(0);
	}
	check_point(0);
}

static uint_t	task3_count = 0;

void
task3(intptr_t exinf)
{
	ER		ercd;
	T_RTSK	rtsk;
	T_RMTX	rmtx;

	switch (++task3_count) {
	case 1:
		check_point(11);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(0);

	case 2:
		check_point(20);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(22);
		ercd = ref_mtx(MTX1, &rmtx);
		check_ercd(ercd, E_OK);
		check_assert(rmtx.htskid == TASK3);
		check_assert(rmtx.wtskid == TSK_NONE);

		ercd = ref_tsk(TASK3, &rtsk);
		check_ercd(ercd, E_OK);
		check_assert(rtsk.tskpri == MID_PRIORITY);

		check_point(23);
		ercd = ext_tsk();

		check_point(0);

	case 3:
		check_point(36);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(0);

	case 4:
		check_point(46);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(49);
		ercd = ref_mtx(MTX1, &rmtx);
		check_ercd(ercd, E_OK);
		check_assert(rmtx.htskid == TASK3);
		check_assert(rmtx.wtskid == TSK_NONE);

		ercd = ref_mtx(MTX2, &rmtx);
		check_ercd(ercd, E_OK);
		check_assert(rmtx.htskid == TASK4);
		check_assert(rmtx.wtskid == TSK_NONE);

		ercd = ref_tsk(TASK3, &rtsk);
		check_ercd(ercd, E_OK);
		check_assert(rtsk.tskpri == MID_PRIORITY);

		ercd = ref_tsk(TASK4, &rtsk);
		check_ercd(ercd, E_OK);
		check_assert(rtsk.tskpri == MID_PRIORITY);

		check_point(50);
		ercd = ext_tsk();

		check_point(0);
	}
	check_point(0);
}

static uint_t	task4_count = 0;

void
task4(intptr_t exinf)
{
	ER		ercd;

	switch (++task4_count) {
	case 1:
		check_point(37);
		ercd = loc_mtx(MTX2);
		check_ercd(ercd, E_OK);

		check_point(0);

	case 2:
		check_point(47);
		ercd = loc_mtx(MTX2);
		check_ercd(ercd, E_OK);

		check_point(51);
		ercd = ext_tsk();

		check_point(0);
	}
	check_point(0);
}
